pipeline {
  environment {
     registry = "vigneshkandra/restaurant"
    registryCredential = 'docker_hub'
    dockerImage = ''
  }
agent any
stages {
 stage('git') {
  steps {
    echo 'checkout code from gitlab'
     git credentialsId: '3', url: 'https://gitlab.com/kandra.vignesh4/fery-restaurant.git'
      }
    }
   stage('npm install package'){
    steps{
      echo "installing the npm package "
          sh '''
          rm -rf node_modules package-lock.json

          npm i -g npm-check-updates
          ncu -u
         
          npm install --unsafe-perm

           chmod -R a+rwx ./node_modules 

          curl -sL https://deb.nodesource.com/setup_12.x | sudo -E bash -
          
          sudo apt-get install -y nodejs

          sudo npm install npm@latest -g

          '''
         }
       }
     
      
    stage('Build docker image'){
      steps{
        echo "Building docker image"
        script{
          dockerImage = docker.build registry + ":$BUILD_NUMBER"
        }
      }
    }
   stage ('Push Docker Image') {
      steps{
        echo "Pushing Docker Image"

withDockerRegistry(credentialsId: '2', url: "") {
sh ''' docker push vigneshkandra/restaurant
'''
}
}
   
      }
    
  
  
    stage ('Deploy to dev Environment') {
      steps{
        echo "deploying to dev environment"
        
     sh "docker rm -f ferry_restaurant || true"
     sh "docker run -t vigneshkandra/restaurant"   
                
        }
      }  
  }
}
